#include <NativeEthernet.h>

byte mac[] = { 0x04, 0xE9, 0xE5, 0x10, 0x00, 0x01 };
IPAddress ip(192, 168, 1, 100);
IPAddress serverIP(192, 168, 1, 101);
const int serverPort = 8888;

EthernetClient client;
#define package_size 1024
byte buffer[package_size];

void setup() {
    Serial.begin(921600);
    //while (!Serial);

    Serial.println("Initializing Ethernet...");
    Ethernet.begin(mac, ip);

    if (Ethernet.hardwareStatus() == EthernetNoHardware) {
        Serial.println("Ethernet hardware not found!");
        while (true);
    }

    if (Ethernet.linkStatus() == LinkOFF) {
        Serial.println("Ethernet cable not connected!");
    }

    Serial.println("Connecting to server...");

    if (client.connect(serverIP, serverPort)) {
        Serial.println("Connected to server!");
    } else {
        Serial.println("Connection failed.");
    }

    for (int i = 0; i < package_size; i++) {
        buffer[i] = i;  // Fill buffer with sample data (0-255)
    }
  send_package();
  send_package();
  send_package();
  send_package();
  send_package();
  delay (3000);
  send_package();

}

void loop() {
    //delay(500);  // Small delay to avoid overloading the receiver
}

void send_package(){
      if (!client.connected()) {
        Serial.println("Connection lost. Reconnecting...");
        client.stop();
        delay(1000);
        client.connect(serverIP, serverPort);
        return;
    }

    //Serial.println("Sending packet...");
    client.write(buffer, package_size);

}
