#include <Teensy4I2C.h>

#define SLAVE_ADDR 0x08
#define BUFFER_SIZE 256

uint8_t receivedData[BUFFER_SIZE];

void receiveEvent(size_t count) {
    I2C.read(receivedData, count);
}

void setup() {
    I2C.begin(SLAVE_ADDR);
    I2C.onReceive(receiveEvent);
    Serial.begin(115200);
}

void loop() {
    delay(500);
    Serial.print("Received Data: ");
    for (int i = 0; i < BUFFER_SIZE; i++) {
        Serial.print(receivedData[i], HEX);
        Serial.print(" ");
    }
    Serial.println();
}
